const path = require('path')
const MiniCssExtractPlugin = require('mini-css-extract-plugin');
const EsmWebpackPlugin = require("@purtuga/esm-webpack-plugin")

const clientFiles = [
  'common-client-plugin.js'
]

const package = require('./package.json')

const config = clientFiles.map(f => ({
  entry: './client/' + f,
  devtool: 'source-map',
  output: {
    path: path.resolve(__dirname, './dist'),
    filename: './' + f,
    library: 'script',
    libraryTarget: 'var',
  },
  plugins: [
    new EsmWebpackPlugin(),
    new MiniCssExtractPlugin(),
  ],
  module: {
    rules: [
      {
        test: /\.(png|svg)$/i,
        loader: 'file-loader',
        options: {
          outputPath: 'images',
          publicPath: `/plugins/${package.name.replace('peertube-plugin-', '')}/${package.version}/static/images/`,
        },
      },
      {
        test: /\.scss$/i,
        use: [MiniCssExtractPlugin.loader, 'css-loader', 'sass-loader'],
      },
      {
        test: /\.js$/,
        // exclude: /(node_modules|bower_components)/,
        use: {
          loader: 'babel-loader',
          options: {
            presets: ['@babel/preset-env']
          }
        }
      }
    ],
  },
}))

module.exports = config
